/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include "binforge.h"

#define BFC_VERSION "0.1.0"

int main(int argc, char **argv)
{
    int s;
    char *buffer;
    char *command;

    if ((command = mallocString(SOCKET_MESSAGE_MAXLEN)) == NULL)
        return 0;

    /*
    bfc -v
    bfc -h
    bfc exists x
    bfc list
    */
    switch (argc) {
        case 2:
            if (!strcmp(argv[1], "-v")) {
                printf("bf %s, bfc %s\n", BF_VERSION, BFC_VERSION);
                free(command);
                return 0;
            }
            if (!strcmp(argv[1], "-h")) {
                printf("Help menu is coming soon :).\n");
                free(command);
                return 0;
            }
            else if (!strcmp(argv[1], "list")) {
                sprintf(command, "?LIST TXT");
            }
            else {
                printf("Error: wrong parameter (type -h for more information).\n");
                free(command);
                return 0;
            }
            break;
        case 3:
            if (!strcmp(argv[1], "exists")) {
                sprintf(command, "?EXISTS %s", argv[2]);
            }
            else {
                printf("Error: wrong parameters (type -h for more information).\n");
                free(command);
                return 0;
            }
            break;
        default:
            printf("Error: wrong parameters number (type -h for more information).\n");
            free(command);
            return 0;
    }

    sck_init();

    s = sck_connect("127.0.0.1", 1487);
    if (s == INVALID_SOCKET) {
        printf("Error: sck_connect() failed.\n");
        return 0;
    }

    if (!strcmp(argv[1], "exists")) {
        sck_sendln(s, command);
        if ((buffer = sck_readln(s, SOCKET_MESSAGE_MAXLEN)) == NULL) {
            printf("Error: something unexpected happend in sck_readln().\n");
            sck_close(s);
            free(buffer);
            free(command);
            return 0;
        }
        if (!strcmp(buffer, "+OK")) {
            if ((buffer = sck_readln(s, SOCKET_MESSAGE_MAXLEN)) == NULL) {
                printf("Error: something unexpected happend in sck_readln().\n");
                sck_close(s);
                free(buffer);
                free(command);
                return 0;
            }
            if (!strcmp(buffer, "!YES"))
                printf("Package found.\n");
            else
                printf("Package not found.\n");
        }
        else
            printf("Error:\n%s\n", buffer+sizeof(char));
    }
    else if (!strcmp(argv[1], "list")) {
        sck_sendln(s, command);
        while ((buffer = sck_readln(s, SOCKET_MESSAGE_MAXLEN)) != NULL) {
            if (!strcmp(buffer, "+START"))
                printf("Beginning of transmission...\n\n");
            else if (!strcmp(buffer, "+END"))
                printf("\nEnd of transmission!\n");
            else if (buffer[0] == '-')
                printf("Error: %s\n", buffer);
            else if (!strcmp(buffer, "+OK"))
                printf("\n");
            else if (!strcmp(buffer, "+PKG INFO"))
                printf("\n");
            else if (buffer[0] == '!')
                printf("%s\n", buffer+sizeof(char));
            else
                printf("%s\n", buffer);
        }
    }
    else {
        printf("Error: wrong parameters number (type -h for more information).\n");
        sck_sendln(s, "?SORRY");
    }

    sck_close(s);
    free(buffer);
    free(command);

    sck_clear();

    return 0;
}
